Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.c	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.c	(revision 3392)
@@ -0,0 +1,148 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <pjmedia/types.h>
+#include <pj/errno.h>
+
+#if PJMEDIA_HAS_LIBAVFORMAT && PJMEDIA_HAS_LIBAVUTIL
+
+#include "ffmpeg_util.h"
+#include <libavformat/avformat.h>
+
+/* Conversion table between pjmedia_format_id and PixelFormat */
+static const struct ffmpeg_fmt_table_t
+{
+    pjmedia_format_id	id;
+    enum PixelFormat	pf;
+} ffmpeg_fmt_table[] =
+{
+    { PJMEDIA_FORMAT_RGBA, PIX_FMT_RGBA},
+    { PJMEDIA_FORMAT_RGB24,PIX_FMT_RGB24},
+    { PJMEDIA_FORMAT_BGRA, PIX_FMT_BGRA},
+
+    { PJMEDIA_FORMAT_AYUV, PIX_FMT_NONE},
+    { PJMEDIA_FORMAT_YUY2, PIX_FMT_YUYV422},
+    { PJMEDIA_FORMAT_UYVY, PIX_FMT_UYVY422},
+    { PJMEDIA_FORMAT_I420, PIX_FMT_YUV420P},
+    { PJMEDIA_FORMAT_YV12, PIX_FMT_YUV422P},
+    { PJMEDIA_FORMAT_I420JPEG, PIX_FMT_YUVJ420P},
+    { PJMEDIA_FORMAT_I422JPEG, PIX_FMT_YUVJ422P},
+};
+
+/* Conversion table between pjmedia_format_id and CodecID */
+static const struct ffmpeg_codec_table_t
+{
+    pjmedia_format_id	id;
+    enum CodecID	codec_id;
+} ffmpeg_codec_table[] =
+{
+    {PJMEDIA_FORMAT_H261,  CODEC_ID_H261},
+    {PJMEDIA_FORMAT_H263,  CODEC_ID_H263},
+    {PJMEDIA_FORMAT_MPEG1VIDEO,  CODEC_ID_MPEG1VIDEO},
+    {PJMEDIA_FORMAT_MPEG2VIDEO,  CODEC_ID_MPEG2VIDEO},
+    {PJMEDIA_FORMAT_MPEG4,  CODEC_ID_MPEG4},    
+    {PJMEDIA_FORMAT_MJPEG,  CODEC_ID_MJPEG},
+};
+
+static int pjmedia_ffmpeg_ref_cnt;
+
+void pjmedia_ffmpeg_add_ref()
+{
+    if (pjmedia_ffmpeg_ref_cnt++ == 0) {
+	av_register_all();
+    }
+}
+
+void pjmedia_ffmpeg_dec_ref()
+{
+    if (pjmedia_ffmpeg_ref_cnt-- == 1) {
+	/* How to shutdown ffmpeg? */
+    }
+
+    if (pjmedia_ffmpeg_ref_cnt < 0) pjmedia_ffmpeg_ref_cnt = 0;
+}
+
+pj_status_t pjmedia_format_id_to_PixelFormat(pjmedia_format_id fmt_id,
+					     enum PixelFormat *pixel_format)
+{
+    unsigned i;
+    for (i=0; i<PJ_ARRAY_SIZE(ffmpeg_fmt_table); ++i) {
+	const struct ffmpeg_fmt_table_t *t = &ffmpeg_fmt_table[i];
+	if (t->id==fmt_id && t->pf != PIX_FMT_NONE) {
+	    *pixel_format = t->pf;
+	    return PJ_SUCCESS;
+	}
+    }
+
+    *pixel_format = PIX_FMT_NONE;
+    return PJ_ENOTFOUND;
+}
+
+pj_status_t PixelFormat_to_pjmedia_format_id(enum PixelFormat pf,
+					     pjmedia_format_id *fmt_id)
+{
+    unsigned i;
+    for (i=0; i<PJ_ARRAY_SIZE(ffmpeg_fmt_table); ++i) {
+	const struct ffmpeg_fmt_table_t *t = &ffmpeg_fmt_table[i];
+	if (t->pf == pf) {
+	    if (fmt_id) *fmt_id = t->id;
+	    return PJ_SUCCESS;
+	}
+    }
+
+    return PJ_ENOTFOUND;
+}
+
+pj_status_t pjmedia_format_id_to_CodecID(pjmedia_format_id fmt_id,
+					 enum CodecID *codec_id)
+{
+    unsigned i;
+    for (i=0; i<PJ_ARRAY_SIZE(ffmpeg_codec_table); ++i) {
+	const struct ffmpeg_codec_table_t *t = &ffmpeg_codec_table[i];
+	if (t->id==fmt_id && t->codec_id != PIX_FMT_NONE) {
+	    *codec_id = t->codec_id;
+	    return PJ_SUCCESS;
+	}
+    }
+
+    *codec_id = PIX_FMT_NONE;
+    return PJ_ENOTFOUND;
+}
+
+pj_status_t CodecID_to_pjmedia_format_id(enum CodecID codec_id,
+					 pjmedia_format_id *fmt_id)
+{
+    unsigned i;
+    for (i=0; i<PJ_ARRAY_SIZE(ffmpeg_codec_table); ++i) {
+	const struct ffmpeg_codec_table_t *t = &ffmpeg_codec_table[i];
+	if (t->codec_id == codec_id) {
+	    if (fmt_id) *fmt_id = t->id;
+	    return PJ_SUCCESS;
+	}
+    }
+
+    return PJ_ENOTFOUND;
+}
+
+
+#ifdef _MSC_VER
+#   pragma comment( lib, "avformat.lib")
+#   pragma comment( lib, "avutil.lib")
+#endif
+
+#endif	/* #if PJMEDIA_HAS_LIBAVFORMAT && PJMEDIA_HAS_LIBAVUTIL */
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.h
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.h	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/ffmpeg_util.h	(revision 3392)
@@ -0,0 +1,55 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/*
+ * This file contains common utilities that are useful for pjmedia components
+ * that use ffmpeg. This is not a public API.
+ */
+
+#ifndef __PJMEDIA_FFMPEG_UTIL_H__
+#define __PJMEDIA_FFMPEG_UTIL_H__
+
+#include <pjmedia/format.h>
+
+#ifdef _MSC_VER
+#   ifndef __cplusplus
+#	define inline _inline
+#   endif
+#   pragma warning(disable:4244) /* possible loss of data */
+#endif
+
+#include <libavutil/avutil.h>
+#include <libavcodec/avcodec.h>
+
+void pjmedia_ffmpeg_add_ref();
+void pjmedia_ffmpeg_dec_ref();
+
+pj_status_t pjmedia_format_id_to_PixelFormat(pjmedia_format_id fmt_id,
+					     enum PixelFormat *pixel_format);
+
+pj_status_t PixelFormat_to_pjmedia_format_id(enum PixelFormat pf,
+					     pjmedia_format_id *fmt_id);
+
+pj_status_t pjmedia_format_id_to_CodecID(pjmedia_format_id fmt_id,
+					 enum CodecID *codec_id);
+
+pj_status_t CodecID_to_pjmedia_format_id(enum CodecID codec_id,
+					 pjmedia_format_id *fmt_id);
+
+#endif /* __PJMEDIA_FFMPEG_UTIL_H__ */
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/format.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/format.c	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/format.c	(revision 3392)
@@ -0,0 +1,366 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <pjmedia/format.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+#include <pj/pool.h>
+#include <pj/string.h>
+
+static pj_status_t apply_packed_fmt(const pjmedia_video_format_info *fi,
+	                            pjmedia_video_apply_fmt_param *aparam);
+
+static pj_status_t apply_planar_420(const pjmedia_video_format_info *fi,
+	                            pjmedia_video_apply_fmt_param *aparam);
+
+static pj_status_t apply_planar_422(const pjmedia_video_format_info *fi,
+	                            pjmedia_video_apply_fmt_param *aparam);
+
+struct pjmedia_video_format_mgr
+{
+    unsigned			max_info;
+    unsigned			info_cnt;
+    pjmedia_video_format_info **infos;
+};
+
+static pjmedia_video_format_mgr *video_format_mgr_instance;
+static pjmedia_video_format_info built_in_vid_fmt_info[] =
+{
+    {PJMEDIA_FORMAT_RGB24, "RGB24", PJMEDIA_COLOR_MODEL_RGB, 24, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_RGBA,  "RGBA", PJMEDIA_COLOR_MODEL_RGB, 32, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_BGRA,  "BGRA", PJMEDIA_COLOR_MODEL_RGB, 32, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_DIB ,  "DIB ", PJMEDIA_COLOR_MODEL_RGB, 24, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_AYUV,  "AYUV", PJMEDIA_COLOR_MODEL_YUV, 32, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_YUY2,  "YUY2", PJMEDIA_COLOR_MODEL_YUV, 16, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_UYVY,  "UYVY", PJMEDIA_COLOR_MODEL_YUV, 16, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_YVYU,  "YVYU", PJMEDIA_COLOR_MODEL_YUV, 16, 1, &apply_packed_fmt},
+    {PJMEDIA_FORMAT_I420,  "I420", PJMEDIA_COLOR_MODEL_YUV, 12, 3, &apply_planar_420},
+    {PJMEDIA_FORMAT_YV12,  "YV12", PJMEDIA_COLOR_MODEL_YUV, 16, 3, &apply_planar_422},
+    {PJMEDIA_FORMAT_I420JPEG, "I420JPG", PJMEDIA_COLOR_MODEL_YUV, 12, 3, &apply_planar_420},
+    {PJMEDIA_FORMAT_I422JPEG, "I422JPG", PJMEDIA_COLOR_MODEL_YUV, 16, 3, &apply_planar_422},
+};
+
+
+PJ_DEF(void) pjmedia_format_init_audio( pjmedia_format *fmt,
+				        pj_uint32_t fmt_id,
+					unsigned clock_rate,
+					unsigned channel_count,
+					unsigned bits_per_sample,
+					unsigned frame_time_usec,
+					pj_uint32_t avg_bps,
+					pj_uint32_t max_bps)
+{
+    fmt->id = fmt_id;
+    fmt->type = PJMEDIA_TYPE_AUDIO;
+    fmt->detail_type = PJMEDIA_FORMAT_DETAIL_AUDIO;
+
+    fmt->det.aud.clock_rate = clock_rate;
+    fmt->det.aud.channel_count = channel_count;
+    fmt->det.aud.bits_per_sample = bits_per_sample;
+    fmt->det.aud.frame_time_usec = frame_time_usec;
+    fmt->det.aud.avg_bps = avg_bps;
+    fmt->det.aud.max_bps = max_bps;
+}
+
+PJ_DEF(void) pjmedia_format_init_video( pjmedia_format *fmt,
+					pj_uint32_t fmt_id,
+					unsigned width,
+					unsigned height,
+					unsigned fps_num,
+					unsigned fps_denum)
+{
+    fmt->id = fmt_id;
+    fmt->type = PJMEDIA_TYPE_VIDEO;
+    fmt->detail_type = PJMEDIA_FORMAT_DETAIL_VIDEO;
+
+    fmt->det.vid.size.w = width;
+    fmt->det.vid.size.h = height;
+    fmt->det.vid.fps.num = fps_num;
+    fmt->det.vid.fps.denum = fps_denum;
+    fmt->det.vid.avg_bps = fmt->det.vid.max_bps = 0;
+
+    if (pjmedia_video_format_mgr_instance()) {
+	const pjmedia_video_format_info *vfi;
+	pjmedia_video_apply_fmt_param vafp;
+	pj_uint32_t bps;
+
+	vfi = pjmedia_get_video_format_info(NULL, fmt->id);
+        if (vfi) {
+	    pj_bzero(&vafp, sizeof(vafp));
+	    vafp.size = fmt->det.vid.size;
+	    vfi->apply_fmt(vfi, &vafp);
+
+	    bps = vafp.framebytes * fps_num * (pj_size_t)8 / fps_denum;
+	    fmt->det.vid.avg_bps = fmt->det.vid.max_bps = bps;
+        }
+    }
+}
+
+PJ_DEF(pjmedia_audio_format_detail*)
+pjmedia_format_get_audio_format_detail(const pjmedia_format *fmt,
+				       pj_bool_t assert_valid)
+{
+    if (fmt->detail_type==PJMEDIA_FORMAT_DETAIL_AUDIO) {
+	return (pjmedia_audio_format_detail*) &fmt->det.aud;
+    } else {
+	pj_assert(!assert_valid || !"Invalid audio format detail");
+	return NULL;
+    }
+}
+
+PJ_DEF(pjmedia_video_format_detail*)
+pjmedia_format_get_video_format_detail(const pjmedia_format *fmt,
+				       pj_bool_t assert_valid)
+{
+    if (fmt->detail_type==PJMEDIA_FORMAT_DETAIL_VIDEO) {
+	return (pjmedia_video_format_detail*)&fmt->det.vid;
+    } else {
+	pj_assert(!assert_valid || !"Invalid video format detail");
+	return NULL;
+    }
+}
+
+PJ_DEF(pjmedia_format*) pjmedia_format_copy(pjmedia_format *dst,
+					    const pjmedia_format *src)
+{
+    return (pjmedia_format*)pj_memcpy(dst, src, sizeof(*src));
+}
+
+
+static pj_status_t apply_packed_fmt(const pjmedia_video_format_info *fi,
+	                            pjmedia_video_apply_fmt_param *aparam)
+{
+    unsigned i;
+    pj_size_t stride;
+
+    stride = (pj_size_t)((aparam->size.w*fi->bpp) >> 3);
+
+    /* Calculate memsize */
+    aparam->framebytes = stride * aparam->size.h;
+
+    /* Packed formats only use 1 plane */
+    aparam->planes[0] = aparam->buffer;
+    aparam->strides[0] = stride;
+    aparam->plane_bytes[0] = aparam->framebytes;
+
+    /* Zero unused planes */
+    for (i=1; i<PJMEDIA_MAX_VIDEO_PLANES; ++i) {
+	aparam->strides[i] = 0;
+	aparam->planes[i] = NULL;
+    }
+
+    return PJ_SUCCESS;
+}
+
+static pj_status_t apply_planar_420(const pjmedia_video_format_info *fi,
+	                             pjmedia_video_apply_fmt_param *aparam)
+{
+    unsigned i;
+    pj_size_t Y_bytes;
+
+    PJ_UNUSED_ARG(fi);
+
+    /* Calculate memsize */
+    Y_bytes = (pj_size_t)(aparam->size.w * aparam->size.h);
+    aparam->framebytes = Y_bytes + (Y_bytes>>1);
+
+    /* Planar formats use 3 plane */
+    aparam->strides[0] = aparam->size.w;
+    aparam->strides[1] = aparam->strides[2] = (aparam->size.w>>1);
+
+    aparam->planes[0] = aparam->buffer;
+    aparam->planes[1] = aparam->planes[0] + Y_bytes;
+    aparam->planes[2] = aparam->planes[1] + (Y_bytes>>2);
+
+    aparam->plane_bytes[0] = Y_bytes;
+    aparam->plane_bytes[1] = aparam->plane_bytes[2] = (Y_bytes>>2);
+
+    /* Zero unused planes */
+    for (i=3; i<PJMEDIA_MAX_VIDEO_PLANES; ++i) {
+	aparam->strides[i] = 0;
+	aparam->planes[i] = NULL;
+        aparam->plane_bytes[i] = 0;
+    }
+
+    return PJ_SUCCESS;
+}
+
+static pj_status_t apply_planar_422(const pjmedia_video_format_info *fi,
+	                             pjmedia_video_apply_fmt_param *aparam)
+{
+    unsigned i;
+    pj_size_t Y_bytes;
+
+    PJ_UNUSED_ARG(fi);
+
+    /* Calculate memsize */
+    Y_bytes = (pj_size_t)(aparam->size.w * aparam->size.h);
+    aparam->framebytes = (Y_bytes << 1);
+
+    /* Planar formats use 3 plane */
+    aparam->strides[0] = aparam->size.w;
+    aparam->strides[1] = aparam->strides[2] = (aparam->size.w>>1);
+
+    aparam->planes[0] = aparam->buffer;
+    aparam->planes[1] = aparam->planes[0] + Y_bytes;
+    aparam->planes[2] = aparam->planes[1] + (Y_bytes>>1);
+
+    aparam->plane_bytes[0] = Y_bytes;
+    aparam->plane_bytes[1] = aparam->plane_bytes[2] = (Y_bytes>>1);
+
+    /* Zero unused planes */
+    for (i=3; i<PJMEDIA_MAX_VIDEO_PLANES; ++i) {
+	aparam->strides[i] = 0;
+	aparam->planes[i] = NULL;
+        aparam->plane_bytes[i] = 0;
+    }
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pj_status_t)
+pjmedia_video_format_mgr_create(pj_pool_t *pool,
+				unsigned max_fmt,
+				unsigned options,
+				pjmedia_video_format_mgr **p_mgr)
+{
+    pjmedia_video_format_mgr *mgr;
+    unsigned i;
+
+    PJ_ASSERT_RETURN(pool && options==0, PJ_EINVAL);
+
+    PJ_UNUSED_ARG(options);
+
+    mgr = PJ_POOL_ALLOC_T(pool, pjmedia_video_format_mgr);
+    mgr->max_info = max_fmt;
+    mgr->info_cnt = 0;
+    mgr->infos = pj_pool_calloc(pool, max_fmt, sizeof(pjmedia_video_format_info *));
+
+    if (video_format_mgr_instance == NULL)
+	video_format_mgr_instance = mgr;
+
+    for (i=0; i<PJ_ARRAY_SIZE(built_in_vid_fmt_info); ++i) {
+	pjmedia_register_video_format_info(mgr,
+					   &built_in_vid_fmt_info[i]);
+    }
+
+    if (p_mgr)
+	*p_mgr = mgr;
+
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(const pjmedia_video_format_info*)
+pjmedia_get_video_format_info(pjmedia_video_format_mgr *mgr,
+			      pj_uint32_t id)
+{
+    pjmedia_video_format_info **first;
+    int		 comp;
+    unsigned	 n;
+
+    if (!mgr)
+	mgr = pjmedia_video_format_mgr_instance();
+
+    PJ_ASSERT_RETURN(mgr != NULL, NULL);
+
+    /* Binary search for the appropriate format id */
+    comp = -1;
+    first = &mgr->infos[0];
+    n = mgr->info_cnt;
+    for (; n > 0; ) {
+	unsigned half = n / 2;
+	pjmedia_video_format_info **mid = first + half;
+
+	if ((*mid)->id < id) {
+	    first = ++mid;
+	    n -= half + 1;
+	} else if ((*mid)->id==id) {
+	    return *mid;
+	} else {
+	    n = half;
+	}
+    }
+
+    return NULL;
+}
+
+
+PJ_DEF(pj_status_t)
+pjmedia_register_video_format_info(pjmedia_video_format_mgr *mgr,
+				   pjmedia_video_format_info *info)
+{
+    unsigned i;
+
+    if (!mgr)
+	mgr = pjmedia_video_format_mgr_instance();
+
+    PJ_ASSERT_RETURN(mgr != NULL, PJ_EINVALIDOP);
+
+    if (mgr->info_cnt >= mgr->max_info)
+	return PJ_ETOOMANY;
+
+    /* Insert to the array, sorted */
+    for (i=0; i<mgr->info_cnt; ++i) {
+	if (mgr->infos[i]->id >= info->id)
+	    break;
+    }
+
+    if (i < mgr->info_cnt) {
+	if (mgr->infos[i]->id == info->id) {
+	    /* just overwrite */
+	    mgr->infos[i] = info;
+	    return PJ_SUCCESS;
+	}
+
+	pj_memmove(&mgr->infos[i+1], &mgr->infos[i],
+		   (mgr->info_cnt - i) * sizeof(pjmedia_video_format_info*));
+    }
+
+    mgr->infos[i] = info;
+    mgr->info_cnt++;
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pjmedia_video_format_mgr*) pjmedia_video_format_mgr_instance(void)
+{
+    pj_assert(video_format_mgr_instance != NULL);
+    return video_format_mgr_instance;
+}
+
+PJ_DEF(void)
+pjmedia_video_format_mgr_set_instance(pjmedia_video_format_mgr *mgr)
+{
+    video_format_mgr_instance = mgr;
+}
+
+
+PJ_DEF(void) pjmedia_video_format_mgr_destroy(pjmedia_video_format_mgr *mgr)
+{
+    if (!mgr)
+	mgr = pjmedia_video_format_mgr_instance();
+
+    PJ_ASSERT_ON_FAIL(mgr != NULL, return);
+
+    mgr->info_cnt = 0;
+    if (video_format_mgr_instance == mgr)
+	video_format_mgr_instance = NULL;
+}
+
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/master_port.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/master_port.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/master_port.c	(revision 3392)
@@ -57,4 +57,5 @@
     unsigned samples_per_frame;
     unsigned bytes_per_frame;
+    pjmedia_audio_format_detail *u_afd, *d_afd;
     pj_status_t status;
 
@@ -62,23 +63,25 @@
     PJ_ASSERT_RETURN(pool && u_port && d_port && p_m, PJ_EINVAL);
 
+    u_afd = pjmedia_format_get_audio_format_detail(&u_port->info.fmt, PJ_TRUE);
+    d_afd = pjmedia_format_get_audio_format_detail(&d_port->info.fmt, PJ_TRUE);
 
     /* Both ports MUST have equal clock rate */
-    PJ_ASSERT_RETURN(u_port->info.clock_rate == d_port->info.clock_rate,
+    PJ_ASSERT_RETURN(u_afd->clock_rate == d_afd->clock_rate,
 		     PJMEDIA_ENCCLOCKRATE);
 
     /* Both ports MUST have equal samples per frame */
-    PJ_ASSERT_RETURN(u_port->info.samples_per_frame==
-		     d_port->info.samples_per_frame,
+    PJ_ASSERT_RETURN(PJMEDIA_PIA_SPF(&u_port->info)==
+			PJMEDIA_PIA_SPF(&d_port->info),
 		     PJMEDIA_ENCSAMPLESPFRAME);
 
     /* Both ports MUST have equal channel count */
-    PJ_ASSERT_RETURN(u_port->info.channel_count == d_port->info.channel_count,
+    PJ_ASSERT_RETURN(u_afd->channel_count == d_afd->channel_count,
 		     PJMEDIA_ENCCHANNEL);
 
 
     /* Get clock_rate and samples_per_frame from one of the port. */
-    clock_rate = u_port->info.clock_rate;
-    samples_per_frame = u_port->info.samples_per_frame;
-    channel_count = u_port->info.channel_count;
+    clock_rate = u_afd->clock_rate;
+    samples_per_frame = PJMEDIA_PIA_SPF(&u_port->info);
+    channel_count = u_afd->channel_count;
 
 
@@ -86,7 +89,7 @@
      * buffer. We take the larger size of the two ports.
      */
-    bytes_per_frame = u_port->info.bytes_per_frame;
-    if (d_port->info.bytes_per_frame > bytes_per_frame)
-	bytes_per_frame = d_port->info.bytes_per_frame;
+    bytes_per_frame = PJMEDIA_AFD_AVG_FSZ(u_afd);
+    if (PJMEDIA_AFD_AVG_FSZ(d_afd) > bytes_per_frame)
+	bytes_per_frame = PJMEDIA_AFD_AVG_FSZ(d_afd);
 
 
@@ -208,4 +211,7 @@
     PJ_ASSERT_RETURN(m && port, PJ_EINVAL);
 
+    /* Only supports audio for now */
+    PJ_ASSERT_RETURN(port->info.fmt.type==PJMEDIA_TYPE_AUDIO, PJ_ENOTSUP);
+
     /* If we have downstream port, make sure they have matching samples per
      * frame.
@@ -213,6 +219,6 @@
     if (m->d_port) {
 	PJ_ASSERT_RETURN(
-	    port->info.clock_rate/port->info.samples_per_frame==
-	    m->d_port->info.clock_rate/m->d_port->info.samples_per_frame,
+	    PJMEDIA_PIA_PTIME(&port->info) ==
+		PJMEDIA_PIA_PTIME(&m->d_port->info),
 	    PJMEDIA_ENCSAMPLESPFRAME
 	);
@@ -246,4 +252,7 @@
 {
     PJ_ASSERT_RETURN(m && port, PJ_EINVAL);
+
+    /* Only supports audio for now */
+    PJ_ASSERT_RETURN(port->info.fmt.type==PJMEDIA_TYPE_AUDIO, PJ_ENOTSUP);
 
     /* If we have upstream port, make sure they have matching samples per
@@ -252,6 +261,6 @@
     if (m->u_port) {
 	PJ_ASSERT_RETURN(
-	    port->info.clock_rate/port->info.samples_per_frame==
-	    m->u_port->info.clock_rate/m->u_port->info.samples_per_frame,
+	    PJMEDIA_PIA_PTIME(&port->info) ==
+		    PJMEDIA_PIA_PTIME(&m->u_port->info),
 	    PJMEDIA_ENCSAMPLESPFRAME
 	);
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_capture.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_capture.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_capture.c	(revision 3392)
@@ -47,5 +47,5 @@
 
 static pj_status_t rec_put_frame(pjmedia_port *this_port, 
-				  const pjmedia_frame *frame);
+				 pjmedia_frame *frame);
 static pj_status_t rec_get_frame(pjmedia_port *this_port, 
 				  pjmedia_frame *frame);
@@ -141,5 +141,5 @@
 
 static pj_status_t rec_put_frame( pjmedia_port *this_port, 
-				  const pjmedia_frame *frame)
+				  pjmedia_frame *frame)
 {
     struct mem_rec *rec;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_player.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_player.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/mem_player.c	(revision 3392)
@@ -49,5 +49,5 @@
 
 static pj_status_t mem_put_frame(pjmedia_port *this_port, 
-				  const pjmedia_frame *frame);
+				 pjmedia_frame *frame);
 static pj_status_t mem_get_frame(pjmedia_port *this_port, 
 				  pjmedia_frame *frame);
@@ -126,5 +126,5 @@
 
 static pj_status_t mem_put_frame( pjmedia_port *this_port, 
-				  const pjmedia_frame *frame)
+				  pjmedia_frame *frame)
 {
     PJ_UNUSED_ARG(this_port);
@@ -166,5 +166,5 @@
     }
 
-    size_needed = this_port->info.bytes_per_frame;
+    size_needed = PJMEDIA_PIA_AVG_FSZ(&this_port->info);
     size_written = 0;
     endpos = player->buffer + player->buf_size;
@@ -201,9 +201,9 @@
     }
 
-    frame->size = this_port->info.bytes_per_frame;
+    frame->size = PJMEDIA_PIA_AVG_FSZ(&this_port->info);
     frame->timestamp.u64 = player->timestamp.u64;
     frame->type = PJMEDIA_FRAME_TYPE_AUDIO;
 
-    player->timestamp.u64 += this_port->info.samples_per_frame;
+    player->timestamp.u64 += PJMEDIA_PIA_SPF(&this_port->info);
 
     return PJ_SUCCESS;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/null_port.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/null_port.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/null_port.c	(revision 3392)
@@ -30,5 +30,5 @@
 				  pjmedia_frame *frame);
 static pj_status_t null_put_frame(pjmedia_port *this_port, 
-				  const pjmedia_frame *frame);
+				  pjmedia_frame *frame);
 static pj_status_t null_on_destroy(pjmedia_port *this_port);
 
@@ -68,5 +68,5 @@
  */
 static pj_status_t null_put_frame(pjmedia_port *this_port, 
-				  const pjmedia_frame *frame)
+				  pjmedia_frame *frame)
 {
     PJ_UNUSED_ARG(this_port);
@@ -83,8 +83,8 @@
 {
     frame->type = PJMEDIA_FRAME_TYPE_AUDIO;
-    frame->size = this_port->info.samples_per_frame * 2;
-    frame->timestamp.u32.lo += this_port->info.samples_per_frame;
+    frame->size = PJMEDIA_PIA_AVG_FSZ(&this_port->info);
+    frame->timestamp.u32.lo += PJMEDIA_PIA_SPF(&this_port->info);
     pjmedia_zero_samples((pj_int16_t*)frame->buf, 
-			 this_port->info.samples_per_frame);
+			  PJMEDIA_PIA_SPF(&this_port->info));
 
     return PJ_SUCCESS;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/port.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/port.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/port.c	(revision 3392)
@@ -22,4 +22,5 @@
 #include <pj/assert.h>
 #include <pj/log.h>
+#include <pj/pool.h>
 
 #define THIS_FILE	"port.c"
@@ -38,22 +39,39 @@
 					    unsigned samples_per_frame)
 {
+#define USEC_IN_SEC (pj_uint64_t)1000000
+    unsigned frame_time_usec, avg_bps;
+
     pj_bzero(info, sizeof(*info));
 
+    info->signature = signature;
+    info->dir = PJMEDIA_DIR_ENCODING_DECODING;
     info->name = *name;
-    info->signature = signature;
-    info->type = PJMEDIA_TYPE_AUDIO;
-    info->has_info = PJ_TRUE;
-    info->need_info = PJ_FALSE;
-    info->pt = 0xFF;
-    info->encoding_name = pj_str("pcm");
-    info->clock_rate = clock_rate;
-    info->channel_count = channel_count;
-    info->bits_per_sample = bits_per_sample;
-    info->samples_per_frame = samples_per_frame;
-    info->bytes_per_frame = samples_per_frame * bits_per_sample / 8;
+
+    frame_time_usec = (unsigned)(samples_per_frame * USEC_IN_SEC /
+				 channel_count / clock_rate);
+    avg_bps = clock_rate * channel_count * bits_per_sample;
+
+    pjmedia_format_init_audio(&info->fmt, PJMEDIA_FORMAT_L16, clock_rate,
+			      channel_count, bits_per_sample, frame_time_usec,
+			      avg_bps, avg_bps);
 
     return PJ_SUCCESS;
 }
 
+PJ_DEF(pj_status_t) pjmedia_port_info_init2( pjmedia_port_info *info,
+					     const pj_str_t *name,
+					     unsigned signature,
+					     pjmedia_dir dir,
+					     const pjmedia_format *fmt)
+{
+    pj_bzero(info, sizeof(*info));
+    info->signature = signature;
+    info->dir = dir;
+    info->name = *name;
+
+    pjmedia_format_copy(&info->fmt, fmt);
+
+    return PJ_SUCCESS;
+}
 
 /**
@@ -78,5 +96,5 @@
  */
 PJ_DEF(pj_status_t) pjmedia_port_put_frame( pjmedia_port *port,
-					    const pjmedia_frame *frame )
+					    pjmedia_frame *frame )
 {
     PJ_ASSERT_RETURN(port && frame, PJ_EINVAL);
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/resample_port.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/resample_port.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/resample_port.c	(revision 3392)
@@ -43,5 +43,5 @@
 
 static pj_status_t resample_put_frame(pjmedia_port *this_port,
-				      const pjmedia_frame *frame);
+				      pjmedia_frame *frame);
 static pj_status_t resample_get_frame(pjmedia_port *this_port, 
 				      pjmedia_frame *frame);
@@ -58,5 +58,5 @@
     const pj_str_t name = pj_str("resample");
     struct resample_port *rport;
-    unsigned ptime;
+    pjmedia_audio_format_detail *d_afd, *r_afd;
     pj_status_t status;
 
@@ -65,9 +65,9 @@
 
     /* Only supports 16bit samples per frame */
-    PJ_ASSERT_RETURN(dn_port->info.bits_per_sample == 16, PJMEDIA_ENCBITS);
-
-    ptime = dn_port->info.samples_per_frame * 1000 / 
-	    dn_port->info.clock_rate;
-    
+    PJ_ASSERT_RETURN(PJMEDIA_PIA_BITS(&dn_port->info) == 16, PJMEDIA_ENCBITS);
+
+    d_afd = pjmedia_format_get_audio_format_detail(&dn_port->info.fmt, 1);
+    r_afd = pjmedia_format_get_audio_format_detail(&rport->base.info.fmt, 1);
+
     /* Create and initialize port. */
     rport = PJ_POOL_ZALLOC_T(pool, struct resample_port);
@@ -75,6 +75,6 @@
 
     pjmedia_port_info_init(&rport->base.info, &name, SIGNATURE, clock_rate,
-			   dn_port->info.channel_count, BYTES_PER_SAMPLE * 8, 
-			   clock_rate * ptime / 1000);
+		           d_afd->channel_count, BYTES_PER_SAMPLE * 8,
+			   clock_rate * d_afd->frame_time_usec / 1000000);
 
     rport->dn_port = dn_port;
@@ -87,9 +87,9 @@
      */
     rport->get_buf = (pj_int16_t*)
-		     pj_pool_alloc(pool, dn_port->info.bytes_per_frame);
+		     pj_pool_alloc(pool, PJMEDIA_PIA_AVG_FSZ(&dn_port->info));
     PJ_ASSERT_RETURN(rport->get_buf != NULL, PJ_ENOMEM);
 
     rport->put_buf = (pj_int16_t*)
-		     pj_pool_alloc(pool, dn_port->info.bytes_per_frame);
+		     pj_pool_alloc(pool, PJMEDIA_PIA_AVG_FSZ(&dn_port->info));
     PJ_ASSERT_RETURN(rport->put_buf != NULL, PJ_ENOMEM);
 
@@ -99,8 +99,8 @@
 				     (opt&PJMEDIA_RESAMPLE_USE_LINEAR)==0,
 				     (opt&PJMEDIA_RESAMPLE_USE_SMALL_FILTER)==0,
-				     dn_port->info.channel_count,
-				     dn_port->info.clock_rate, 
-				     rport->base.info.clock_rate,
-				     dn_port->info.samples_per_frame, 
+				     d_afd->channel_count,
+				     d_afd->clock_rate,
+				     r_afd->clock_rate,
+				     PJMEDIA_PIA_SPF(&dn_port->info),
 				     &rport->resample_get);
     if (status != PJ_SUCCESS)
@@ -111,8 +111,8 @@
 				     (opt&PJMEDIA_RESAMPLE_USE_LINEAR)==0, 
 				     (opt&PJMEDIA_RESAMPLE_USE_SMALL_FILTER)==0,
-				     dn_port->info.channel_count,
-				     rport->base.info.clock_rate, 
-				     dn_port->info.clock_rate,
-				     rport->base.info.samples_per_frame,
+				     d_afd->channel_count,
+				     r_afd->clock_rate,
+				     d_afd->clock_rate,
+				     PJMEDIA_PIA_SPF(&rport->base.info),
 				     &rport->resample_put);
 
@@ -132,5 +132,5 @@
 
 static pj_status_t resample_put_frame(pjmedia_port *this_port,
-				      const pjmedia_frame *frame)
+				      pjmedia_frame *frame)
 {
     struct resample_port *rport = (struct resample_port*) this_port;
@@ -148,5 +148,5 @@
 
 	downstream_frame.buf = rport->put_buf;
-	downstream_frame.size = rport->dn_port->info.bytes_per_frame;
+	downstream_frame.size = PJMEDIA_PIA_AVG_FSZ(&rport->dn_port->info);
     } else {
 	downstream_frame.buf = frame->buf;
@@ -176,5 +176,5 @@
 
     tmp_frame.buf = rport->get_buf;
-    tmp_frame.size = rport->dn_port->info.bytes_per_frame;
+    tmp_frame.size = PJMEDIA_PIA_AVG_FSZ(&rport->dn_port->info);
     tmp_frame.timestamp.u64 = frame->timestamp.u64;
     tmp_frame.type = PJMEDIA_FRAME_TYPE_AUDIO;
@@ -188,6 +188,6 @@
 	frame->timestamp = tmp_frame.timestamp;
 	/* Copy whatever returned as long as the buffer size is enough */
-	frame->size = tmp_frame.size < rport->base.info.bytes_per_frame ?
-		      tmp_frame.size : rport->base.info.bytes_per_frame;
+	frame->size = tmp_frame.size < PJMEDIA_PIA_AVG_FSZ(&rport->base.info) ?
+		      tmp_frame.size : PJMEDIA_PIA_AVG_FSZ(&rport->base.info);
 	if (tmp_frame.size) {
 	    pjmedia_copy_samples((pj_int16_t*)frame->buf, 
@@ -202,5 +202,5 @@
 			  (pj_int16_t*) frame->buf);
 
-    frame->size = rport->base.info.bytes_per_frame;
+    frame->size = PJMEDIA_PIA_AVG_FSZ(&rport->base.info);
     frame->type = PJMEDIA_FRAME_TYPE_AUDIO;
 
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/silencedet.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/silencedet.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/silencedet.c	(revision 3392)
@@ -24,4 +24,5 @@
 #include <pj/log.h>
 #include <pj/pool.h>
+#include <pj/string.h>
 
 #define THIS_FILE   "silencedet.c"
